import java.net.*;
import java.io.*;

public class GestisciRicezione extends Thread{
	Socket ricez=null;
	DataInputStream in=null;
	MioServer parent;
	String user,pass,mode;
	int set,fil,pos,count;
				
	GestisciRicezione(MioServer sup,Socket nuova){
		parent=sup;
		ricez=nuova;
	}
	
	public void run(){
		
		try{
				BufferedInputStream bis=new BufferedInputStream(ricez.getInputStream());
				in=new DataInputStream(bis);
				//Ricevo dati
				user=in.readUTF();
				pass=in.readUTF();
				mode=in.readUTF();
		}catch(IOException e){
			System.err.println("Colleg. impossibile:  "+
							e.getMessage());
		};
		parent.info.append("Nuova connessione:  "+user+"\nOperazione:         "+mode+"\n");
		//verifica utente
		boolean correct=false;
		for(int i=0;i<parent.numUsers;i++)
			if (user.equals(parent.TrueUsers[i]))
				if (pass.equals(parent.TruePass[i]))
					correct=true;
		if(!correct){
			parent.info.append("Login di utente non\n  autorizzato:  "+user+"\n");
			try{
				in.close();
				ricez.close();
			}catch(IOException e) {
				System.err.println("Errore nella chiusura dello Stream");
			}
			return;
		}
		//verifica tipo richiesta
		if(mode.equals("AGG"))Aggiorna();
		else{
			//leggo ulteriori info
			try{
					set=in.readInt();
					fil=in.readInt();
					pos=in.readInt();
					count=in.readInt();
			}catch(IOException e){
					System.err.println("Colleg. impossibile:  "+e.getMessage());
			}
		if(mode.equals("RIC")) SoddisfaRichiesta();
		if (mode.equals("VER")) VerificaPosto();
		}
	}
	
	public void Aggiorna(){
		try{
				//invio aggiornamento settori
				DataOutputStream out=new DataOutputStream(new BufferedOutputStream(ricez.getOutputStream()));
				for(int s=0;s<4;s++)
					for(int p=0;p<20;p++)
						out.writeInt(parent.Set[s].pos[p]);
				out.close();
				in.close();
				ricez.close();
			}catch(IOException e){
			System.err.println("Colleg. impossibile:  "+e.getMessage());
			};
			parent.info.append("Aggiornamento totale di\n  "+user+" completato.\n");
			System.out.println("agg compl");
	}	
	
	public void SoddisfaRichiesta(){
		int posto=pos+fil*5;
		boolean stato=false,mio=false;
		
		mio=parent.Set[set].setPosto(posto,user,count);
		//coordinazione con server2
		if(mio){
			stato=LanciaCoord();
			if(!stato)
				parent.info.append("Segnalazione di incoerenza\n  fra i database.\nContattare server2\n");
		}else stato=false;
		try{
			DataOutputStream out=new DataOutputStream(new BufferedOutputStream(ricez.getOutputStream()));
			out.writeBoolean(stato);
			//agg settore
			if(!stato)
				for(int p=0;p<20;p++)
					out.writeInt(parent.Set[set].pos[p]);
			out.flush();
			in.close();
			out.close();
			ricez.close();
		}catch(IOException e){
			System.err.println("Colleg. impossibile:  "+e.getMessage());
		}
	}
	
	public void VerificaPosto(){
		int posto=pos+fil*5;
		boolean stato,mio;
		String OldUser;
		int OldCount;
		
		mio=parent.Set[set].setPosto(posto,user,count);
		//coordinazione con server2
		if(mio){
			stato=LanciaCoord();
			if(!stato)
				parent.info.append("Segnalazione di incoerenza\n  fra i database.\nContattare server2\n");
		}else{
			//verifica chi lo possiede e decidi stato
			if ((parent.Set[set].user[posto].equals(user))&
				(parent.Set[set].count[posto]==count)) stato=true;
			else stato=false;
		}
		try{
			DataOutputStream out=new DataOutputStream(new BufferedOutputStream(ricez.getOutputStream()));
			out.writeBoolean(stato);
			if(!stato)
				for(int i=0;i<20;i++)
					out.writeInt(parent.Set[set].pos[i]);
			out.flush();
			in.close();
			out.close();
			ricez.close();
		}catch(IOException e){
			System.err.println("Colleg. impossibile:  "+e.getMessage());
		};
	}
	
	public boolean LanciaCoord(){
		boolean res=false;
		
		try{
				Socket SocCoord=new Socket(parent.Serv2,parent.Port2);
				BufferedOutputStream bos2=new BufferedOutputStream(SocCoord.getOutputStream());
				DataOutputStream out2=new DataOutputStream(bos2);
				out2.writeUTF("ORD");
				out2.writeUTF(user);
				out2.writeUTF(pass);
				out2.writeInt(set);
				out2.writeInt(fil);
				out2.writeInt(pos);
				out2.writeInt(count);
				out2.flush();
				//Ricevo risposta da server2
				BufferedInputStream bis2=new BufferedInputStream(SocCoord.getInputStream());
				DataInputStream in2=new DataInputStream(bis2);
				res=in2.readBoolean();
				out2.close();
				in2.close();
				SocCoord.close();
			}catch(IOException e){
				parent.info.append("Server2 down\n");
				return true;
			};
			return res;
	}
}